﻿using System;

using UIKit;
using System.Threading.Tasks;
using Foundation;

namespace testInvoke
{
    public partial class ViewController : UIViewController
    {
        public ViewController(IntPtr handle)
            : base(handle)
        {
        }

        public override void ViewDidLoad()
        {
            base.ViewDidLoad();
            // Perform any additional setup after loading the view, typically from a nib.
        }

        public override void DidReceiveMemoryWarning()
        {
            base.DidReceiveMemoryWarning();
            // Release any cached data, images, etc that aren't in use.
        }

        partial void UIButton3_TouchUpInside(UIButton sender)
        {
            Task.Run(() =>
                {
                    Function();
                });

            Task.Run(() =>
                {
                    Function();
                });
        }

        void Function()
        {
            const string htmlString = "<html>\n    <head>\n        <title>Title</title>\n    </head>\n    <body>\n        <div align=”center”>Hello World!</div>\n    </body>\n</html>";
            InvokeOnMainThread(() =>
                {
                    var guid = Guid.NewGuid();

                    Console.WriteLine("STEP 1" + " GUID: " + guid);

                    htmlString.ToNSAttributedString(NSDocumentType.HTML);

                    Console.WriteLine("STEP 2" + " GUID: " + guid);
                });
        }

    }

    public static class StringExtensions
    {

        public static NSString ToNSString(this string str)
        {
            return new NSString(str);
        }

        public static NSAttributedString ToNSAttributedString(this string str, NSDocumentType type, UIFont font = null)
        {
            try
            {
                if (string.IsNullOrEmpty(str))
                {
                    return null;
                }

                var data = NSData.FromString(str);

                var options = new NSAttributedStringDocumentAttributes();
                options.DocumentType = type;
                var _unused = new NSDictionary();
                var error = new NSError("Convert to NSAttributedString error.".ToNSString(), 887);
                var attrstr = new NSAttributedString(data, options, out _unused, ref error);
                if (error != null)
                {
                    return null;
                }

                if (font != null)
                {
                    var attrstrCopy = new NSMutableAttributedString(attrstr);
                    attrstrCopy.AddAttribute(UIStringAttributeKey.Font, font, new NSRange(0, attrstr.Length));
                    return attrstrCopy;
                }

                return attrstr;
            }
            catch (Exception e)
            {
                return null;
            }
        }
    }
}

